/*
 * AgentListener.java
 *
 * Created on 16. januar 2007, 20:17
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
package CoreSys;

import java.net.*;
import java.io.*;
/**
 *
 * @author Sindre Soltun
 */
public class CommListener extends Thread{
    private ServerSocket ss;
    private int port;
    private SystemManager sys;
        
    /** Creates a new instance of CommListener */
    public CommListener(int port, SystemManager s){
        this.port = port;
        sys = s;
        try{
            ss = new ServerSocket(port);
        }
        catch(IOException x){
            System.out.println("Could not listen to port "+port);
            x.printStackTrace();
            
        }
    }
    /** Listens for new connections */
    public void listen(){
        Socket cs = null;
        if(ss != null){
            try{
                cs = ss.accept();
                System.out.println("New connection!");
            }
            catch(IOException x){
                System.out.println("Accept failed on "+port);
            }
            try{
                PrintWriter out = new PrintWriter(cs.getOutputStream(), true);
                BufferedReader in = new BufferedReader(new InputStreamReader(cs.getInputStream()));
                String input;
                input = in.readLine();
                int msgType = Integer.parseInt(input);
                if(msgType == 2){
                    String[] set = new String[2];
                    for(int i = 0 ; i < 2 ; i++){
                        set[i] = in.readLine();
                        System.out.println(set[i]);
                    }
                    int response = sys.checkLogin(set[0],set[1]);
                    if(response==1){
                        out.println(1);
                    }
                    else{
                        out.println(2);
                    }
                }
            }
            catch(IOException x){
                System.out.println("I/O stream error!");
            }
        }
    }
    /** Creates new tread with the listen process */
    public void run(){
        listen();
    }
}
