/*
 * DatabaseHandler.java
 *
 * Created on 4. desember 2006, 12:00
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package CoreSys;

import java.sql.*;
import javax.sql.*;
import javax.sql.rowset.*;
import java.util.*;
/**
 *
 * @author Sindre Soltun
 */
public class DatabaseHandler{
    private ResultSet resultset;
    private Connection con;
    
    /** Creates a new instance of DatabaseHandler */
    public DatabaseHandler() {
        try{
            Class.forName("org.apache.derby.jdbc.ClientDriver");
            con = DriverManager.getConnection("jdbc:derby://localhost:1527/optiDB","soltun","soltun");
        }
        catch(ClassNotFoundException cnfe){
            System.out.println(cnfe);
        }
        catch(SQLException sqle){
            System.out.println(sqle);
        }
    }
    
    public ResultSet retrieveValues(String[] field, String[] table, String[] constraint){
        resultset = null;
        
        String find = "select ";
        for(int i = 0 ; i < field.length ; i++){
            find += field[i];
            if(i < (field.length - 1)){
                find += ", ";
            }
        }
        if(table != null){
            find += " from ";
            for(int i = 0 ; i < table.length ; i++){
                find += table[i];
                if(i < (table.length - 1)){
                    find += ", ";
                }
            }
        }
        if(constraint != null){
            find += " where ";
            for(int i = 0 ; i < constraint.length ; i++){
                find += constraint[i];
                if(i < (constraint.length - 1)){
                    find += " and ";
                }
            }
        }
        System.out.println(find);
        try{
            Statement stmt = con.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_UPDATABLE);
            resultset = stmt.executeQuery(find); 
        }
        catch(SQLException sqle){
            System.out.println("Catch i retrieveValues!");
            sqle.printStackTrace();
        }
        return resultset;
    }
    
    public void updateRow(String table, String[] concolumns, Object[] cons, String[] inscolumns, Object[] values){
        String[] col = new String[1];
        col[0] = "*";
        String[] t = new String[1];
        t[0] = table;
        resultset = retrieveValues(col,t,null);
        try{
           resultset.beforeFirst();
           System.out.println("Fr satt rad");
           while(resultset.next()){
                boolean found = false;
                for(int i = 0 ; i < concolumns.length ; i++){
                    if(cons[i] instanceof String){
                        if(resultset.getString(concolumns[i]).equals((String)cons[i])){
                            found = true;
                        }
                    }
                    else{
                        if(resultset.getInt(concolumns[i])==(Integer)cons[i]){
                            found = true;
                        }
                    }
                }
                if(found){
                    break;
                }
           }
           if(!resultset.isAfterLast()){
               for(int i = 0 ; i < inscolumns.length ; i++){
                    if(values[i] instanceof String){
                        resultset.updateString(inscolumns[i],(String)values[i]);
                    }
                    else{
                        resultset.updateInt(inscolumns[i],(Integer)values[i]);
                    }                    
               }
               resultset.updateRow();
           }
           else{
               System.out.println("Requested updatable object not in database!");
           }
           resultset.close();
        }
        
        catch(SQLException sqle){
            System.out.println("Catch i addValues!");
            System.out.println(sqle.getSQLState());
        }
    }
    
    public void addRow(String table, String[] columns, Object[] values){
        String[] col = new String[1];
        col[0] = "*";
        String[] t = new String[1];
        t[0] = table;
        resultset = retrieveValues(col,t,null);
        System.out.println(resultset==null);
        try{
            resultset.moveToInsertRow();
            System.out.println("forbi movetoInsert");
            for(int i = 0; i < columns.length ; i++){
                if(values[i] instanceof String){
                    resultset.updateString(columns[i],(String)values[i]);
                    System.out.println("Legger til string: "+resultset.getString(columns[i]));
                }
                else if(values[i] instanceof Integer){
                    Integer v = (Integer)values[i];
                    String val = v.toString();
                    resultset.updateInt(columns[i], Integer.parseInt(val));
                    System.out.println("Legger til int: "+resultset.getString(columns[i]));
                }
                else{
                    System.out.println("Parsing error!");
                }
            }
            resultset.insertRow();
            System.out.println("Kommer hit!");
            resultset.moveToCurrentRow();
            resultset.close();
        }
        catch(SQLException sqle){
            System.out.println("Catch i addValues!");
            System.out.println(sqle.getSQLState());
        }
    }
    
    public void removeRow(String table, String[] columns, Object[] constraint){
        String[] t = new String[1];
        t[0] = table;
        String[] c = new String[1];
        c[0] = "*";
        resultset = retrieveValues(c,t,null);
        System.out.println(resultset == null);
        try{
           resultset.beforeFirst();
           System.out.println("Fr satt rad");
           while(resultset.next()){
                boolean found = false;
                for(int i = 0 ; i < columns.length ; i++){
                    if(constraint[i] instanceof String){
                        if(resultset.getString(columns[i]).equals((String)constraint[i])){
                            found = true;
                        }
                    }
                    else{
                        if(resultset.getInt(columns[i])==(Integer)constraint[i]){
                            found = true;
                        }
                    }
                }
                if(found){
                    resultset.deleteRow();
                    System.out.println("Job deleted!");
                    break;
                }
           }
           resultset.close();
        }
        catch(SQLException sqle){
            System.out.println(sqle);
        }
    }  
   
}
