/*
 * AgentListener.java
 *
 * Created on 16. januar 2007, 21:24
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package CoreSys;

import java.io.*;
import java.net.*;
/**
 *
 * @author Sindre Soltun
 */
public class CommListener extends Thread{
   private ServerSocket ss;
    private int port;
    private SystemManager sys;
        
    /** Creates a new instance of CommListener */
    public CommListener(int port, SystemManager s){
        this.port = port;
        sys = s;
        try{
            ss = new ServerSocket(port);
        }
        catch(IOException x){
            System.out.println("Could not listen to port "+port);
            x.printStackTrace();
            
        }
    }
    /** Listens for new connections. */
    public void listen(){
        Socket cs = null;
        if(ss != null){
            try{
                cs = ss.accept();
                System.out.println("New connection!");
            }
            catch(IOException x){
                System.out.println("Accept failed on "+port);
            }
            try{
                PrintWriter out = new PrintWriter(cs.getOutputStream(), true);
                BufferedReader in = new BufferedReader(new InputStreamReader(cs.getInputStream()));
                String input;
                input = in.readLine();
                int msgType = Integer.parseInt(input);
                if(msgType == 2){
                    out.println(1);
                }
            }
            catch(IOException x){
                System.out.println("I/O stream error!");
            }
        }
    }
    /** Starts a new thread when executed.*/
    public void run(){
        listen();
    }
}
