/*
 * AgentHandler.java
 *
 * Created on 16. januar 2007, 19:37
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package CoreSys;

import java.net.*;
import java.io.*;
/**
 *
 * @author Sindre Soltun
 */
public class CommInitialiser {
    private int port;
    private Socket s;
    private PrintWriter pw;
    private BufferedReader br;
    /** Creates a new instance of CommListener */
    public CommInitialiser(int port){
        this.port = port;
        
    }
    /** Sends a message to the requested host */
    public void send(String host, String message){
        try{
            s = new Socket(host,port);
            pw = new PrintWriter(s.getOutputStream(),true);
            br = new BufferedReader(new InputStreamReader(s.getInputStream()));
        }
        catch(UnknownHostException u){
            System.out.println("Unknown host!");
        }
        catch(IOException i){
            System.out.println("I/O error!");
        }
        BufferedReader stbr = new BufferedReader(new InputStreamReader(System.in));
        
        String input;
        try{
            while((input = stbr.readLine()) != null){
                pw.println(input);
                System.out.println("Input returnert: "+br.readLine());                
            }
        }
        catch(IOException i){
            System.out.println("I/O error!");
        }
        try{
            pw.close();
            br.close();
            stbr.close();
            s.close();
        }
        catch(IOException i){
            System.out.println("Error closing sockets and streams!");
        }
    }
    
}
