/*
 * AgentHandler.java
 *
 * Created on 16. januar 2007, 21:24
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package CoreSys;

import java.net.*;
import java.io.*;
/**
 *
 * @author Sindre Soltun
 */
public class CommInitialiser {
    private int port;
    private Socket s;
    private PrintWriter pw;
    private BufferedReader br;
    /** Creates a new instance of CommInitialiser */
    public CommInitialiser(int port){
        this.port = port;
        
    }
    /** Sends a message to the requested host. */
    public int send(String host, String[] message){
        try{
            s = new Socket(host,port);
            pw = new PrintWriter(s.getOutputStream(),true);
            br = new BufferedReader(new InputStreamReader(s.getInputStream()));
        }
        catch(UnknownHostException u){
            System.out.println("Unknown host!");
        }
        catch(IOException i){
            System.out.println("I/O error!");
        }
        int response = 0;
        int msgType = Integer.parseInt(message[0]);
        for(int i = 0 ; i < message.length ; i++){
            pw.println(message[i]);
        }
        
        try{
            String reply = br.readLine();
            System.out.println(reply);
            response = Integer.parseInt(reply);
            
            pw.close();
            br.close();
            s.close();
        }
        catch(IOException i){
            System.out.println("Error closing sockets and streams!");
        }
        return response;
    }
    
}
